function test_SortTable_all() {
  var tablenode = burst.xml.DomUtil.structToNode(
    ['table', {border: 1}, 
      ['thead', null, ['tr', null, ['th', {sortComparator: 'integer:10'}, 'Number'], ['th', null, 'String']]],
      ['tbody', null, 
        ['tr', null, ['td', null, 17], ['td', null, 'bear']],
        ['tr', null, ['td', null, 3], ['td', null, 'camel']],
        ['tr', null, ['td', null, 5], ['td', null, 'ant']]
      ]
    ]);
  jum.debug('(test_SortTable.js) creating test DOM table');
  document.body.appendChild(tablenode);

  jum.debug('(test_SortTable.js) creating SortTable instance');
  var tablewidget = new burst.webui.widgets.SortTable(tablenode, true);
  
  jum.debug('(test_SortTable.js) checking configured sortComparator');
  jum.assertEquals('integer:10 comparator', 'integer:10', tablewidget.head_widgets_[0].sortComparator);

  // table/thead/tr/th
  var th0 = tablenode.firstChild.firstChild.firstChild;
  var th1 = th0.nextSibling;

  jum.debug('(test_SortTable.js) dispatching first column event');
  burst.web.WindowEvent.dispatchClick(th0);
  jum.debug('(test_SortTable.js) dispatching second column event');
  burst.web.WindowEvent.dispatchClick(th1);
}

